#define _CRT_SECURE_NO_DEPRECATE //disable deprecation warnings
#define _AFX_SECURE_NO_DEPRECATE
 
#include "stdafx.h"

#include "csbrickconnect.h"

#include "cstringt.h"
#include <iostream>
#include <fstream>
#include <string>

const int kNPARAMETERS = 18 ;

const char* TConfiguration::ShowPar()
{   
   int j ;   
   char* buffer = new char[kNPARAMETERS * MAXSTRLEN] ;   
    
   j  = sprintf_s( buffer     , MAXSTRLEN , "BRICKPATH     : %s\r\n" ,  path            );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "PREDICTIONS   : %s\r\n" ,  cs2file         );      
   j += sprintf_s( buffer + j , MAXSTRLEN , "CSSPOTMARKSET : %s\r\n" ,  csspot_markset  );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "LATERALMARKSET: %s\r\n" ,  lateral_markset );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "WORKINGPATH   : %s\r\n" ,  workdir         );     
   j += sprintf_s( buffer + j , MAXSTRLEN , "RAWDATAPATH   : %s\r\n" ,  rawdir          );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "TLGDATAPATH   : %s\r\n" ,  tlgdir          );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "SCANSVRIP     : %s\r\n" ,  scanip          );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "SCANSVRCONFIG : %s\r\n" ,  scanconf        );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "LISTSCANPATH  : %s\r\n" ,  listscanpath    );      
   j += sprintf_s( buffer + j , MAXSTRLEN , "BATCHLINKPATH : %s\r\n" ,  batchlinkpath   );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "BATCHLINKCONF : %s\r\n" ,  batchlinkconfig );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "TLGSELPATH    : %s\r\n" ,  tlgselpath      );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "TLG2TXTPATH   : %s\r\n" ,  tlg2txtpath     );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "FOUNDPATH     : %s\r\n" ,  foundpath       );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "MCRESULTSPATH : %s\r\n" ,  mcresultspath   );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "MCSCANSVRCONFIG: %s\r\n",  mcscanconf      );   
   j += sprintf_s( buffer + j , MAXSTRLEN , "MERGERESULTS  : %s\r\n" ,  mergeresults    );   
         
   return buffer ;
}

void TConfiguration::SetDefaults()
{   
   /*
   sprintf_s ( path            , MAXSTRLEN , "C:\\Users\\sirri\\Desktop"                                         ) ;   
   sprintf_s ( cs2file         , MAXSTRLEN , "C:\\Users\\sirri\\Desktop\\%%d\\pred\\cs2.txt"                     ) ;   
   sprintf_s ( csspot_markset  , MAXSTRLEN , "C:\\Users\\sirri\\Desktop\\%%d\\marks\\csspot.txt"                 ) ;   
   sprintf_s ( lateral_markset , MAXSTRLEN , "C:\\Users\\sirri\\Desktop\\%%d\\marks\\%%d_57_mapX_DB.txt"         ) ;   
   sprintf_s ( workdir         , MAXSTRLEN , "C:\\Users\\sirri\\Desktop\\%%d\\work\\csbrickconnection"           ) ;   
   sprintf_s ( rawdir          , MAXSTRLEN , "C:\\Users\\sirri\\Desktop\\%%d\\work\\csbrickconnection\\rawdata"  ) ;   
   sprintf_s ( tlgdir          , MAXSTRLEN , "C:\\Users\\sirri\\Desktop\\%%d\\work\\csbrickconnection\\tlgdata"  ) ;   
   sprintf_s ( scanip          , MAXSTRLEN , "192.168.7.%%d"                      ) ;      
   sprintf_s ( scanconf        , MAXSTRLEN , "c:\\users\\sirri\\desktop\\MIC%%d_ScanningConfig_CSBrick.xml" ) ;   
   sprintf_s ( listscanpath    , MAXSTRLEN , "C:\\WORKSPACE\\WIP\\PlateChanger\\ListScan\\bin\\Release\\listscan.exe" ) ;
   sprintf_s ( batchlinkpath   , MAXSTRLEN , "S:\\BatchLink.exe" ) ;
   sprintf_s ( batchlinkconfig , MAXSTRLEN , "P:\\ANALISYS\\cs-brick-connection\\scanconfig\\batch_link_cfg.xml" ) ;
   sprintf_s ( tlgselpath      , MAXSTRLEN , "S:\\TLGSel.exe" ) ;
   sprintf_s ( tlg2txtpath     , MAXSTRLEN , "P:\\ANALISYS\\cs-brick-connection\\tlg2txt.exe" ) ;
   sprintf_s ( foundpath       , MAXSTRLEN , "C:\\Users\\sirri\\Desktop\\%%d\\work\\csbrickconnection\\%%d_found.txt" ) ;
   sprintf_s ( mcresultspath   , MAXSTRLEN , "C:\\Users\\sirri\\Desktop\\%%d\\work\\csbrickconnection\\%%d_found_manualcheck.txt" ) ;
   sprintf_s ( mcscanconf      , MAXSTRLEN , "c:\\users\\sirri\\desktop\\MIC%%d_ScanningConfig_CSBrick_nofog_nogrid.xml" ) ;   
   sprintf_s ( mergeresults    , MAXSTRLEN , "C:\\Users\\sirri\\Desktop\\%%d\\work\\csbrickconnection\\mergeresults.txt" ) ;   
*/

   sprintf_s ( path            , MAXSTRLEN , "P:\\RUN2008");
   sprintf_s ( cs2file         , MAXSTRLEN , "P:\\RUN2008\\%%d\\pred\\cs2.txt");
   sprintf_s ( csspot_markset  , MAXSTRLEN , "P:\\RUN2008\\%%d\\marks\\csspot.txt");
   sprintf_s ( lateral_markset , MAXSTRLEN , "P:\\RUN2008\\%%d\\marks\\%%d_57_mapX_DB.txt");
   sprintf_s ( workdir         , MAXSTRLEN , "P:\\RUN2008\\%%d\\work\\csbrickconnection\\listfiles");
   sprintf_s ( rawdir          , MAXSTRLEN , "P:\\SCRATCH\\%%d");
   sprintf_s ( tlgdir          , MAXSTRLEN , "P:\\RUN2008\\%%d\\work\\csbrickconnection\\tlgdata");
   sprintf_s ( scanip          , MAXSTRLEN , "192.168.7.%%d");
   sprintf_s ( scanconf        , MAXSTRLEN , "P:\\RUN2008\\cs_brick\\config\\MIC%%d_ScanningConfig_CSBrick.xml");
   sprintf_s ( listscanpath    , MAXSTRLEN , "P:\\RUN2008\\cs_brick\\release\\listscan.exe");
   sprintf_s ( batchlinkpath   , MAXSTRLEN , "s:\\BatchLink.exe");
   sprintf_s ( batchlinkconfig , MAXSTRLEN , "P:\\RUN2008\\cs_brick\\config\\batch_link_cfg.xml");
   sprintf_s ( tlgselpath      , MAXSTRLEN , "s:\\TLGSel.exe");
   sprintf_s ( tlg2txtpath     , MAXSTRLEN , "P:\\RUN2008\\cs_brick\\release\\tlg2txt.exe");
   sprintf_s ( foundpath       , MAXSTRLEN , "P:\\RUN2008\\%%d\\work\\csbrickconnection\\%%d_found.txt");
   sprintf_s ( mcresultspath   , MAXSTRLEN , "P:\\RUN2008\\%%d\\work\\csbrickconnection\\%%d_found_manualcheck.txt");
   sprintf_s ( mcscanconf      , MAXSTRLEN , "P:\\RUN2008\\cs_brick\\config\\MIC%%d_ScanningConfig_CSBrick_for_manualcheck.xml");
   sprintf_s ( mergeresults    , MAXSTRLEN , "P:\\RUN2008\\%%d\\work\\csbrickconnection\\mergeresults.txt");


}

int TConfiguration::ReadConfig(const char* file) 
{    
   

   try{      
      char  buf[MAXSTRLEN];      
      char  key[MAXSTRLEN];      
      
      FILE *fp ;      
      errno_t err;      
      if( (err  = fopen_s( &fp, file,"r" )) !=0 )         
         return -1;      
      
      while( fgets(buf,MAXSTRLEN,fp)!=NULL ) 
      {	      
         for( int i=0; i<(int)strlen(buf); i++ ) 	      
            if( buf[i]=='#' ) {		      
               buf[i]='\0';			// cut out comments starting from #		      
               break;	      
            }	      
            if( sscanf_s( buf, "%s", key, sizeof(key) )!=1 )              
               continue;	

            if     (!strcmp(key,"BRICKPATH"     )) { sscanf_s ( buf+strlen(key), "%s", path            , MAXSTRLEN  ); }         
            else if(!strcmp(key,"PREDICTIONS"   )) { sscanf_s ( buf+strlen(key), "%s", cs2file         , MAXSTRLEN  ); }	      
            else if(!strcmp(key,"CSSPOTMARKSET" )) { sscanf_s ( buf+strlen(key), "%s", csspot_markset  , MAXSTRLEN  ); }         
            else if(!strcmp(key,"LATERALMARKSET")) { sscanf_s ( buf+strlen(key), "%s", lateral_markset , MAXSTRLEN  ); }         
            else if(!strcmp(key,"WORKINGPATH"   )) { sscanf_s ( buf+strlen(key), "%s", workdir         , MAXSTRLEN  ); }	      
            else if(!strcmp(key,"RAWDATAPATH"   )) { sscanf_s ( buf+strlen(key), "%s", rawdir          , MAXSTRLEN  ); }	      
            else if(!strcmp(key,"TLGDATAPATH"   )) { sscanf_s ( buf+strlen(key), "%s", tlgdir          , MAXSTRLEN  ); }	      
            else if(!strcmp(key,"SCANSVRIP"     )) { sscanf_s ( buf+strlen(key), "%s", scanip          , MAXSTRLEN  ); }	      
            else if(!strcmp(key,"SCANSVRCONFIG" )) { sscanf_s ( buf+strlen(key), "%s", scanconf        , MAXSTRLEN  ); }	      
            else if(!strcmp(key,"LISTSCANPATH"  )) { sscanf_s ( buf+strlen(key), "%s", listscanpath    , MAXSTRLEN  ); }      
            else if(!strcmp(key,"BATCHLINKPATH" )) { sscanf_s ( buf+strlen(key), "%s", batchlinkpath   , MAXSTRLEN  ); }	      
            else if(!strcmp(key,"BATCHLINKCONF" )) { sscanf_s ( buf+strlen(key), "%s", batchlinkconfig , MAXSTRLEN  ); }      
            else if(!strcmp(key,"TLGSELPATH"    )) { sscanf_s ( buf+strlen(key), "%s", tlgselpath      , MAXSTRLEN  ); }      
            else if(!strcmp(key,"TLG2TXTPATH"   )) { sscanf_s ( buf+strlen(key), "%s", tlg2txtpath     , MAXSTRLEN  ); }      
            else if(!strcmp(key,"FOUNDPATH"     )) { sscanf_s ( buf+strlen(key), "%s", foundpath       , MAXSTRLEN  ); }  
            else if(!strcmp(key,"MCRESULTSPATH" )) { sscanf_s ( buf+strlen(key), "%s", mcresultspath   , MAXSTRLEN  ); }  
            else if(!strcmp(key,"MCSCANCONFIG"  )) { sscanf_s ( buf+strlen(key), "%s", mcscanconf      , MAXSTRLEN  ); }	      
            else if(!strcmp(key,"MERGERESULTS"  )) { sscanf_s ( buf+strlen(key), "%s", mergeresults    , MAXSTRLEN  ); }	      


            // how to read integer      
            //		else if ( !strcmp(key,"COM")   )      
            //		{      
            //			sscanf(buf+strlen(key),"%d",ivar);      
            //			kCOM=ivar[0];      
            //		}      
            // how to read float      
            //		else if ( !strcmp(key,"BOTTOMVIEWSHIFT_Z")   )      
            //		{      
            //			sscanf(buf+strlen(key),"%f",fvar);      
            //         kBotshift_Z=fvar[0];      
            //		}      
      
      }      fclose(fp);   
   } catch (...) { return -1 ; };	
   
   return 0; 
}
//___________________________________________________________________________//

void TPrediction::ProjectTo( double z ) 
{
   fP.X += z * fP.SX ;
   fP.Y += z * fP.SY ;
   fP.Z  = z ;
}
//___________________________________________________________________________//
const char* TPrediction::Print() 
{
   char* buf = new char[256];
   sprintf_s( buf, 255, "%8d %8.1f %8.1f %8.1f %8.4f %8.4f %3d", fP.ID, fP.X, fP.Y, fP.Z, fP.SX, fP.SY, fP.NGrains );
   return buf ;
}
//___________________________________________________________________________//
const char* TPrediction::PrintCandidate( int i ) 
{
   if  (i<0||i>=NCandidates()) 
      return "" ;

   char* buf = new char[256];
   sprintf_s( buf, 255, "%8d %8.1f %8.1f %8.1f %8.4f %8.4f %3d %8.4f", 
      fF[i].ID, fF[i].X, fF[i].Y, fF[i].Z, fF[i].SX, fF[i].SY, fF[i].NGrains, fF[i].sigma );
   return buf ;
}
//___________________________________________________________________________//
const char* TPrediction::PrintCandidateForManualCheck( int i ) 
{
   if  (i<0||i>=NCandidates()) 
      return "" ;

   char* buf = new char[256];
  // sprintf_s( buf, 255, "MC,%d,%.1f,%.1f,%.4f,%.4f,%.1f,%.4f", 
  //    fF[i].ID, fF[i].X, fF[i].Y, fF[i].SX, fF[i].SY, post_tol, slope_tol );
   sprintf_s( buf, 255, "MC,%d,%.1f,%.1f,%.4f,%.4f", 
      fF[i].ID, fF[i].X, fF[i].Y, fF[i].SX, fF[i].SY);
   return buf ;
}
//___________________________________________________________________________//
const char* TPrediction::PrintCandidateResiduals( int i ) 
{
   if  (i<0||i>=NCandidates()) 
      return "" ;

   char* buf = new char[256];
   sprintf_s( buf, 255, "%8.1f %8.1f %8.4f %8.4f", 
       fF[i].X  - fP.X  , 
       fF[i].Y  - fP.Y  ,
       fF[i].SX - fP.SX , 
       fF[i].SY - fP.SY );
   return buf ;
}
//___________________________________________________________________________//
const char* TPrediction::PrintScanZone() 
{
   zone_t zone = fScanZone ;
   char* buf = new char[256];
   sprintf_s( buf, 255, "%8d %8.1f %8.1f %8.1f %8.1f\n", fP.ID, zone.X.min, zone.X.max, zone.Y.min, zone.Y.max );
   return buf ;
}
//___________________________________________________________________________//
const char* TPrediction::PrintScanZone_forListScan(const char* folder, int plate_number, int trial_number) 
{
   zone_t zone = fScanZone ;
   char* buf = new char[256];
   sprintf_s( buf, 255, "%d,%.1f,%.1f,%.1f,%.1f,%s", 
      fP.ID, zone.X.min, zone.X.max, zone.Y.min, zone.Y.max,
      FileName( folder, plate_number, trial_number, "" ) );
   return buf ;
}
//___________________________________________________________________________//
const char* TPrediction::FileName( const char* folder, int plate_number, int trial_number, const char* extension)
{
   char* buf = new char[256];
   sprintf_s( buf, 255, "%s\\pl%02d_%02d_pred%08d%s", 
      folder, plate_number, trial_number, fP.ID, extension );
   return buf ;
}
//___________________________________________________________________________//
const char* TPrediction::RawDataFileName( const char* folder, int plate_number, int trial_number )
{
   return FileName( folder, plate_number, trial_number, ".rwc" ) ;
}
//___________________________________________________________________________//
const char* TPrediction::TlgDataFileName( const char* folder, int plate_number, int trial_number )
{
   return FileName( folder, plate_number, trial_number, ".tlg" ) ;
}
//___________________________________________________________________________//
const char* TPrediction::TlgSelectedDataFileName( const char* folder, int plate_number, int trial_number )
{
   return FileName( folder, plate_number, trial_number, ".selected.tlg" ) ;
}
//___________________________________________________________________________//
const char* TPrediction::TxtSelectedDataFileName( const char* folder, int plate_number, int trial_number )
{
   return FileName( folder, plate_number, trial_number, ".selected.txt" ) ;
}
//___________________________________________________________________________//
void TPrediction::EvalScanZone( double size_x, double size_y ) 
{
   zone_t zone ;
   zone.X.min = fP.X - size_x /2. ;
   zone.X.max = fP.X + size_x /2. ;
   zone.Y.min = fP.Y - size_y /2. ;
   zone.Y.max = fP.Y + size_y /2. ;

   fScanZone = zone ;
}
//___________________________________________________________________________//
const char* TPrediction::SelectionString( double res_pos , 
                             double res_ang , 
                             double increase_with_slope )
{
   char* buf = new char[256];
//   sprintf_s( buf, 255, "abs(s.eX-%.1f)<%.1f&&abs(s.eY-%.1f)<%.1f&&abs(s.eTX-%.4f)<%.4f&&abs(s.eTY-%.4f)<%.4f",
   sprintf_s( buf, 255, "abs(PX-(%.1f))<%.1f&&abs(PY-(%.1f))<%.1f&&abs(SX-(%.4f))<%.4f&&abs(SY-(%.4f))<%.4f",
      fP.X  ,  res_pos,
      fP.Y  ,  res_pos, 
      fP.SX ,  res_ang*( 1 + abs( fP.SX ) * increase_with_slope ) ,
      fP.SY ,  res_ang*( 1 + abs( fP.SY ) * increase_with_slope ) );

   return buf ;

}
//___________________________________________________________________________//
void TPrediction::AddCandidate( const char* line ) throw (...)
{
   int id, ngrains;
   float x, y, sx, sy, sigma;
   try{
      char seps[]   = " \t";
      char* nexttoken ;
      char* token ;
      token = strtok_s( const_cast<char*>(line) , seps , &nexttoken) ; 
                                                   if(!token)throw""; if( sscanf_s( token, "%d", &id ) != 1 ) throw "" ;
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%f", &x  ) != 1 ) throw "" ;      
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%f", &y  ) != 1 ) throw "" ;      
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%f", &sx ) != 1 ) throw "" ;      
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%f", &sy ) != 1 ) throw "" ;      
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%d", &ngrains)!= 1 ) throw "" ;
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%f", &sigma)!= 1 ) throw "" ;
   } catch(...) { throw "error formatting string"; }

   segment_t seg = {id,x,y,0,sx,sy,ngrains,sigma} ;

   AddCandidate ( seg  );
}
//___________________________________________________________________________//
int TPrediction::ReadCandidates(const char* fname) throw (...)
{
   ClearCandidates() ;
   try {
     std::string line;
     std::ifstream in( fname );
     if (!in) 
        throw "" ; 
      while( std::getline(in,line) ) {
         AddCandidate( line.c_str() );
      }
      in.close() ;
   } catch(...) { throw "error reading file"; }
   return NCandidates() ;
}
//___________________________________________________________________________//


// TPredictionSet methods

//___________________________________________________________________________//
int TPredictionSet::ReadPredictions(const char* fname) throw (...)
{
   Clear() ;
   try {
     std::string line;
     std::ifstream in( fname );
     if (!in) 
        throw "" ; 
      while( std::getline(in,line) ) {
         AddSegment( line.c_str() );
      }
      in.close() ;
   } catch(...) { throw "error reading file"; }
   return N() ;
}
//___________________________________________________________________________//
const char* TPredictionSet::Print() 
{
   char* buf = new char[256*N()];
   int len=0 ;
   for (int i=0;i< N(); i++)
      len += sprintf_s( buf+len, 255, "%s\r\n", GetPrediction(i)->Print() );
   return buf ;
}
//___________________________________________________________________________//
const char* TPredictionSet::PrintCandidates() 
{
   int ncandidates = 0 ;
   for (int i=0;i< N(); i++)
      ncandidates += GetPrediction(i)->NCandidates() ;

   char* buf = new char[256*ncandidates + 256*N() ];
   int len=0 ;
   for (int i=0;i< N(); i++) {
      TPrediction* p = GetPrediction(i) ;
      len += sprintf_s( buf+len, 255, "%s found: %d\r\n", p->Print(), p->NCandidates() ) ;
      for (int j=0; j<p->NCandidates() ; j++ )
         len += sprintf_s( buf+len, 255, "%s %s\r\n", p->PrintCandidate(j), p->PrintCandidateResiduals(j) );
      len += sprintf_s( buf+len, 10, "\r\n");
   }
   
   return buf ;
}
//___________________________________________________________________________//
void TPredictionSet::AddSegment( const char* line ) throw (...)
{
   int id, ngrains;
   float x, y, sx, sy;
   try{
      char seps[]   = " \t";
      char* nexttoken ;
      char* token ;
      token = strtok_s( const_cast<char*>(line) , seps , &nexttoken) ; 
                                                   if(!token)throw""; if( sscanf_s( token, "%d", &id ) != 1 ) throw "" ;
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%f", &x  ) != 1 ) throw "" ;      
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%f", &y  ) != 1 ) throw "" ;      
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%f", &sx ) != 1 ) throw "" ;      
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%f", &sy ) != 1 ) throw "" ;      
      token = strtok_s( NULL, seps, &nexttoken ) ; if(!token)throw""; if( sscanf_s( token, "%d", &ngrains)!= 1 ) throw "" ;
   } catch(...) { throw "error formatting string"; }

   AddSegment ( TPrediction( id, x, y, 0 , sx, sy , ngrains ) );
}
//___________________________________________________________________________//
void TPredictionSet::ProjectTo( double z )
{
   for (int i=0;i< N(); i++)
      GetPrediction(i)->ProjectTo( z ) ;
}
//___________________________________________________________________________//
void  TPredictionSet::EvaluateScanZones (double size_x, double size_y) 
{
   for (int i=0;i< N(); i++)
      GetPrediction(i)->EvalScanZone( size_x, size_y) ;
}
//___________________________________________________________________________//
const char*  TPredictionSet::PrintScanZones()
{
   char* buf = new char[256*N()];
   int len=0 ;
   for (int i=0;i< N(); i++)
      len += sprintf_s( buf+len, 255, "%s\r\n", GetPrediction(i)->PrintScanZone() );
   return buf ;
}
//___________________________________________________________________________//
void TPredictionSet::CreateZoneListFile( const char* fname, int brick_number, int plate_number, 
                                         const char* map_fname, const char* rawfolder, 
                                         int trial_number ) throw (...)
{
   char* map = new char[1024];

   try{
         std::string line;
         std::ifstream in( map_fname );
         if (!in) 
            throw "" ; 
         if( std::getline(in,line) == 0 ) 
            throw "" ;

         //sostituzione dei primi 2 id del mapping qui
         int pos  = line.find(":") +1;
         int npos = line.find(";") - pos ;
         char* ins = new char[64] ;
         sprintf( ins, "%d %d %d %d" , brick_number, plate_number, 0 , 0 ) ;
         line.replace( pos, npos, ins ) ;

         sprintf_s( map, 1024, "%s", line.c_str() );

         in.close() ;
   } catch(...) { throw "error reading map file"; }   

   try{
      FILE* stream ;
      if( fopen_s( &stream, fname, "w" ) !=0 )
         throw "The file was not opened\n" ;
      fprintf( stream, "%d,%d,%s\n", brick_number, plate_number, map ) ;
      for (int i=0;i< N(); i++) {
         fprintf( stream, "%s\n", GetPrediction(i)->PrintScanZone_forListScan( rawfolder , plate_number, trial_number) );
      }
      fclose( stream ) ;
   } catch(...) { throw "error writing file"; }
}
//___________________________________________________________________________//
void TPredictionSet::SaveCandidates( const char* fname, int trial_number) throw (...)
{
   try{

      FILE* stream ;
      if( fopen_s( &stream, fname, "a+" ) !=0 )
         throw "The file was not opened\n" ;
      
      fprintf( stream, "#TRIAL: %d\r\n", trial_number ) ;
      fprintf( stream, "%s\r\n", PrintCandidates() ) ;
      fclose( stream ) ;
  
   } catch(...) { throw "error writing file"; }
}
//___________________________________________________________________________//
const char* TPredictionSet::CandidatesFileName( const char* folder, int brick_number, int plate_number )
{
   char* buf = new char[256];
   sprintf_s( buf, 255, "%s\\%08d_%02d_found.txt", folder, brick_number, plate_number );
   return buf ;
}
//___________________________________________________________________________//
const char* TPredictionSet::PrintCandidatesForManualCheck( const char* results_fname , int brick_number, int plate_number, float plate_z, int trial_number, const char* map_fname , double pos_tol, double slope_tol) 
{
   char* map = new char[2048];

   try{
         std::string line;
         std::ifstream in( map_fname );
         if (!in) 
            throw "" ; 
         if( std::getline(in,line) == 0 ) 
            throw "" ;

         //sostituzione dei primi 2 id del mapping qui
         int pos  = line.find(":") +1;
         int npos = line.find(";") - pos ;
         char* ins = new char[64] ;
         sprintf( ins, "%d %d %d %d" , brick_number, plate_number, 0 , 0 ) ;
         line.replace( pos, npos, ins ) ;

         sprintf_s( map, 2047, "%s", line.c_str() );
         in.close() ;
   } catch(...) { throw "error reading map file"; }   

   int ncandidates = 0 ;
   for (int i=0;i< N(); i++)
      ncandidates += GetPrediction(i)->NCandidates() ;

   char* buf = new char[ 512+ strlen(map)+strlen(results_fname) + 256*ncandidates+ 256*N() ];
   int len=0 ;
   len += sprintf_s( buf+len, 127+strlen(map), "%d,%d,%s\n", brick_number, plate_number, map ) ;
   len += sprintf_s( buf+len, 127+strlen(results_fname), "MC,%s\n", results_fname ) ;
   len += sprintf_s( buf+len, 128, "BRICK %d   PLATE %d   Z %.1f   TRIAL %d\n", brick_number, plate_number, plate_z, trial_number) ;
   for (int i=0;i< N(); i++) {
      TPrediction* p = GetPrediction(i) ;
      len += sprintf_s( buf+len, 255, "%s\n", p->Print() ) ;
      for (int j=0; j<p->NCandidates() ; j++ )
         len += sprintf_s( buf+len, 255, "%s,%f,%f\n", p->PrintCandidateForManualCheck(j), pos_tol, slope_tol) ;
   }
   
   return buf ;
}//___________________________________________________________________________//
void TPredictionSet::CreateZoneListFileForManualCheck( const char* zonelist_fname , 
                                                   const char* results_fname, 
                                                   int brick_number, 
                                                   int plate_number, 
                                                   float plate_z, 
                                                   int trial_number,
                                                   const char* map_fname, 
                                                   double pos_tol, 
                                                   double slope_tol 
                                                   ) throw (...)
{
   try{

      FILE* stream ;
      if( fopen_s( &stream, zonelist_fname, "w" ) !=0 )
         throw "The file was not opened\n" ;
      
      fprintf( stream, "%s\r\n", PrintCandidatesForManualCheck( results_fname, brick_number, plate_number, plate_z, trial_number, map_fname , pos_tol, slope_tol) ) ;
      fclose( stream ) ;
  
   } catch(...) { throw "error writing file"; }
}
//___________________________________________________________________________//
const char* TPredictionSet::CandidatesFileNameForManualCheck( const char* folder, int brick_number, int plate_number )
{
   char* buf = new char[256];
   sprintf_s( buf, 255, "%s\\%08d_%02d_found_manualcheck.txt", folder, brick_number, plate_number );
   return buf ;
}
//___________________________________________________________________________//
bool TPredictionSet::IsNewTrial( const char* file, int trial ) 
{
   char* substr = new char[64];
   sprintf( substr, "#TRIAL: %d", trial) ;

   int res ;

   std::ifstream in( file );
   std::string line;
   while( std::getline(in,line) != 0 ) 
   {
      res = line.find( substr ) ;
      if ( res == 0)
      {   
         in.close() ;
         return false ;
      }
   }
   in.close() ;
   return true;
}
//___________________________________________________________________________//
const char* TPredictionSet::MergeResults(  int brick_number, 
                                            const char* outputfname, 
                                            const char* mcresultspath ) 
{
   FILE* stream ;
   if( fopen_s( &stream, outputfname, "w" ) !=0 )
      throw "The file was not opened\n" ;
   
   int   first_plate = 0 ;
   const float kNOTVALIDZ = -999999999. ;
   float z0 = kNOTVALIDZ ;
      
   fprintf( stream, "    PL  TRIAL     ID    FID   MAN_PX   MAN_PY   MAN_SX   MAN_SY      DPX      DPY      DSX      DSY  PROJ_PX  PROJ_PY  PROJ_SX  PROJ_SY \n");

   char* fname = new char[256];
   for (int i=60; i>0; i--)
   {
      sprintf_s(fname, 255, mcresultspath , brick_number , i ) ;

      std::ifstream in( fname );
      if (!in) 
         continue ;

      if (first_plate==0)
         first_plate=i ;
      
      std::string line ;
      int brick, plate, trial ;
      float z ;
      int ngr;
      float ppx, ppy, ppz, psx, psy, fpx, fpy, fsx, fsy, mpx, mpy, msx, msy ;
      int pred_id, found_id ;

      int   ivar[10] ;
      float fvar[10] ;

      while( std::getline(in,line) != 0 ) 
      {
         int tok =0;

         // BRICK INFO
         tok = sscanf(line.c_str(), "BRICK %d   PLATE %d   Z %f   TRIAL %d", 
            &ivar[0], &ivar[1], &fvar[2], &ivar[3] ) ;
         if (  tok == 4 ) 
         {
            //DEBUG fprintf( stream, "%d %s\r\n", tok, line.c_str() ) ;
            brick = ivar[0] ;
            plate = ivar[1] ;
            z     = fvar[2] ;
            trial = ivar[3] ;
            
            if ( z0 == kNOTVALIDZ ) z0 = z ;
         }

         tok = sscanf(line.c_str(), "%d %f %f %f %f %f %d ", 
            &ivar[0], &fvar[1], &fvar[2], &fvar[3], &fvar[4], &fvar[5], &ivar[6] ) ;
         // cs2 pred
         if (  tok == 7 ) 
         {
           //DEBUG fprintf( stream, "%d %s\r\n", tok, line.c_str() ) ;
            pred_id =  ivar[0] ;
            ppx     =  fvar[1] ;
            ppy     =  fvar[2] ;
            ppz     =  fvar[3] ;
            psx     =  fvar[4] ;
            psy     =  fvar[5] ;
            ngr     =  ivar[6] ;
         }

         // manual check found
         tok = sscanf(line.c_str(), "%d %f %f %f %f found %f %f %f %f ", 
            &ivar[0], &fvar[1], &fvar[2], &fvar[3], &fvar[4], &fvar[5], &fvar[6], &fvar[7], &fvar[8] ) ;
         if (  tok == 9 ) 
         {
            //DEBUG fprintf( stream, "%d %s\r\n", tok, line.c_str() ) ;
            found_id  =  ivar[0] ;
            fpx       =  fvar[1] ;
            fpy       =  fvar[2] ;
            fsx       =  fvar[3] ;
            fsy       =  fvar[4] ;
            mpx       =  fvar[5] ;
            mpy       =  fvar[6] ;
            msx       =  fvar[7] ;
            msy       =  fvar[8] ;

            fprintf( stream, "%6d %6d %6d %6d ", plate, trial, pred_id, found_id );
            fprintf( stream, "%8.1f %8.1f %8.4f %8.4f ", mpx, mpy, msx, msy );
            fprintf( stream, "%8.1f %8.1f %8.4f %8.4f ", mpx-ppx, mpy-ppy, msx-psx, msy-psy );
            fprintf( stream, "%8.1f %8.1f %8.4f %8.4f ", mpx+(z0-z)*msx, mpy+(z0-z)*msy, msx, msy );
            fprintf( stream, "\n" );
         }
      }       
   }

   delete [] fname ;

   fclose( stream ) ;
   return "" ;
}


